g_ydgwsearchtip = '请输入想查找的商品';

var YDGouwuPopup = {
    vendor: '',
    version: '',
    logUrlPrefix: "http://zhushou.huihui.cn/log?",

    init: function() {
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		                getService(Components.interfaces.nsIPrefService);
	    prefs = prefs.getBranch("extensions.youdaogouwu.");
        this.version = prefs.getCharPref("currentversion");
        this.vendor = prefs.getCharPref("vendor");

        var searchBox = document.getElementById('searchbox');
        searchBox.value = g_ydgwsearchtip;
        searchBox.addEventListener('focus', function() {
            if (searchBox.value === g_ydgwsearchtip) {
                searchBox.value = '';
                searchBox.style.color = 'black';
            }
            searchBox.style.borderColor = '#F9BE52';
        }, false);
        searchBox.addEventListener('blur', function() {
            if (searchBox.value === '') {
                searchBox.value = g_ydgwsearchtip;
                searchBox.style.color = '#CCC';
            }
            searchBox.style.borderColor = '#BABABA';
        }, false);
    },

    onLogo : function() {
        var url = "http://www.huihui.cn/?keyfrom=extension_button";
        this.navigateUrl(url, true);
        this.sendLog('ACTION', 'CLICK_LOGO_BUTTON');
        document.getElementById('ydgw-popup-window').hidePopup();
    },

    onSearch: function() {
        var searchBox = document.getElementById('searchbox');
        if (searchBox.value === g_ydgwsearchtip) { 
            this.blink();
            return false;
        } else {
            var url = 'http://www.huihui.cn/search?keyfrom=extesion_button&q=';
            var key = encodeURI(searchBox.value);
            this.navigateUrl(url+key, true);
            this.sendLog('ACTION', 'SEARCH_BUTTON');
            document.getElementById('ydgw-popup-window').hidePopup();
            return true;
        }
    },

    onSuggest: function() {
        var url = 'http://zhushou.huihui.cn/suggest?keyfrom=extesion_button';
        this.navigateUrl(url, true);
        this.sendLog('ACTION', 'SUGGEST_BUTTON');
        document.getElementById('ydgw-popup-window').hidePopup();
    },

    onHelp: function () {
        var url = "http://zhushou.huihui.cn/features?keyfrom=extension_button";
        this.navigateUrl(url, true);
        this.sendLog('ACTION', 'HELP_BUTTON');
        document.getElementById('ydgw-popup-window').hidePopup();
    },
    
    onDiscount: function () {
        var url = "http://www.huihui.cn/deals?keyfrom=extension";
        this.navigateUrl(url, true);
        this.sendLog('ACTION', 'DISCOUNT_BUTTON');
        document.getElementById('ydgw-popup-window').hidePopup();
    },

    navigateUrl: function(url, jump) {
	    if (!url || url.length === 0) return;
        var tabbrowser = gBrowser;
        var tabs = tabbrowser.tabContainer.childNodes;
        for (var i = 0; i < tabs.length; ++i) {
            var tab = tabs[i];
            try {
                var browser = tabbrowser.getBrowserForTab(tab);
                if (browser) {
                    var doc = browser.contentDocument;
                    var loc = doc.location.toString();
                    if (loc == url) {
                        gBrowser.selectedTab = tab;
                        return;
                    }
                }
            } catch (e) { }
        }

        var tabb = gBrowser.addTab(url, null, null);
        if (jump == undefined || jump)
            gBrowser.selectedTab = tabb;
    },

    sendLog: function(type, action) {
        var url = this.logUrlPrefix;
        if (type == 'INSTALL') {
            url += 'type=ARMANI_EXTENSION_INSTALL' + '&' + 
                'version=' + this.version + '&' + 
                'vendor=' + this.vendor + '&' + 
                'browser=firefox';
        } else if (type == 'ACTION') {
            url += 'type=ARMANI_EXTENSION_ACTION' + '&' + 
                'action=' + action + '&' + 
                'version=' + this.version + '&' + 
                'vendor=' + this.vendor; + '&' + 
                'browser=firefox';
            }
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.send(null);
     },

    blink: function () {
        var counter = 0;
        var colorArr = ['#F9BE52', '#BABABA'];
        var searchBox = document.getElementById('searchbox');
        var timer = setInterval(function() {
            searchBox.style.borderColor = colorArr[counter % colorArr.length];
            counter++;
            if (counter > 7) {
                searchBox.style.removeProperty('border-color');
                clearInterval(timer);
            }
        },
        100);
    }
};

window.addEventListener("load", function() {
    YDGouwuPopup.init();
}, false);

